class ShapeMatrix implements Cloneable {

    private int numRows; // row indices are 1, ..., numRows
    private int numCols; // col indices are 1, ..., numCols
    public int value;
    public int price;
    public int start;
    public int end;
    public RowShapeMatrix[] rowShapeMatrixArray;

    // ------------------------------------------------------------------------

    public ShapeMatrix() {}

    // ------------------------------------------------------------------------

    public ShapeMatrix(int numRows1, int numCols1) {

	numRows = numRows1;
	numCols = numCols1;

	rowShapeMatrixArray = new RowShapeMatrix[numRows + 1];
    }

    // ------------------------------------------------------------------------

    protected Object clone() {

	try {
	    ShapeMatrix s = (ShapeMatrix) super.clone();

	    s.rowShapeMatrixArray
		= (RowShapeMatrix []) rowShapeMatrixArray.clone();

	    return s;
	}
	catch (CloneNotSupportedException e) {

	    throw new InternalError();
	}
    }

    // ------------------------------------------------------------------------

    // Returns string of internal 

    public String debug() {

	String s = "shape matrix (numRows, numCols, value, price, start, end,"
	    + "row shape matrix array):\n";

	s += "\t("
	    + numRows + ","
	    + numCols + ", "
	    + value + ", "
	    + price + ", "
	    + start + ", "
	    + end + ", (";

	for (int i = 1; i < rowShapeMatrixArray.length; i++)

	    s += i + ": " + rowShapeMatrixArray[i];

	return s;
    }

    // ------------------------------------------------------------------------

    public String toString() {

	int[][] matrix = new int[numRows + 1][numCols + 1];

	for (int i = start; i <= end; i++) {

	    RowShapeMatrix r = rowShapeMatrixArray[i];

	    if (r != null)

		for (int j = r.left; j < r.right; j++)

		    matrix[i][j] = value;
	}
	return Matrix.toString(matrix);
    }
}
